import 'package:flutter/material.dart';
import 'package:image_picker/image_picker.dart';
import 'package:video_compress/video_compress.dart';
import 'package:file_selector/file_selector.dart';
import 'dart:io';

import './video_thumbnail.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key? key, this.title}) : super(key: key);

  final String? title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  String _counter = "video";

  @override
  void initState() {
    super.initState();
    VideoCompress.compressProgress$.subscribe((progress) {
      print('isCompressing ${VideoCompress.isCompressing}');
      if (progress > 0) {
        print('progress: $progress');
        // setState(() {
        // compprogress = progress;
        // });
      }
    });
  }

  _compressVideo() async {
    print('_compressVideo 0');
    var file;
    // if (Platform.isMacOS) {
    //   final typeGroup = XTypeGroup(label: 'videos', extensions: ['mov', 'mp4']);
    //   file = await openFile(acceptedTypeGroups: [typeGroup]);
    // } else {
    print('_compressVideo 1');
    final picker = ImagePicker();
    // PickedFile? pickedFile = await picker.getVideo(source: ImageSource.gallery);
    final XFile? pickedFile =
        await picker.pickVideo(source: ImageSource.gallery);
    print('_compressVideo 2');
    file = File(pickedFile!.path);
    // }
    print('_compressVideo 3');
    if (file == null) {
      return;
    }
    print('_compressVideo # file.path : ${file.path}');
    await VideoCompress.setLogLevel(0);
    final MediaInfo? info = await VideoCompress.compressVideo(
      file.path,
      // quality: VideoQuality.Res1920x1080Quality,
      quality: VideoQuality.LowQuality,
      deleteOrigin: false,
      includeAudio: true,
    );

    if (info != null) {
      print(info.path);
      setState(() {
        _counter = info.path!;
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title!),
      ),
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text(
              'You have pushed the button this many times:',
            ),
            Text(
              '$_counter',
              style: Theme.of(context).textTheme.headline4,
            ),
            InkWell(
                child: Text('Cancel'),
                onTap: () async {
                  await VideoCompress.cancelCompression();
                  print('canceled');
                }),
            ElevatedButton(
              onPressed: () {
                Navigator.push(
                  context,
                  MaterialPageRoute(builder: (context) => VideoThumbnail()),
                );
              },
              child: Text('Test thumbnail'),
            ),
          ],
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: () async => _compressVideo(),
        tooltip: 'Increment',
        child: Icon(Icons.add),
      ),
    );
  }
}
